# -----------------------------------------------------------------------------
sub orantTSFull
{
  ($thishost) = @_;

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if ($t_diskcrit[$thishost] eq "" && $t_diskwarn[$thishost] eq "")
  {
    logit("T_TS_Full: Not Specified",$thishost);
    &history_dummy($thishost);
    return;
  }

  if ($g_history_to_file eq "Y")
  { 
    # Check to see if  we need to create history data
    chop($filedate = `date +%C%y.%m.%d`);
    chop($filetime = `date +%H:%M:%S`);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Setting flag to create tblspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;
    }
  }

  @lines = split(/\n/,$orantTSStack[$thishost]);

  $total_size = "";
  $total_used = "";
  $pgmflag = 0;

  $total_size = 0;
  $total_free = 0;
  $total_used = 0;
  $total_df   = 0;

  $orantTSStack = "";

  &logDetails($thishost,"<h3>Oracle Tablespaces</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Tablespace<th>$f_s Type<th>$f_s Datafile<br> Count<th>$f_s Size (MB)<th>$f_s Used (MB)<th>$f_s Free (MB)<th>$f_s Percent Full<th>$f_s (W)arning<br>(C)ritical<br>(A)utoextend</tr>");

  foreach (@lines)
  {
    &parse;
    ##print "F0=$F0 \n";

    $ts    = $F3;
    $type  = $F4;
    $numd  = $F5;
    $size  = $F6;
    $used  = $F7;
    $free  = $F8;
    $pct   = $F9;
    $stat  = $F10;

    $f_size = sprintf "%9.2f",$size;
    $f_used = sprintf "%9.2f",$used;
    $f_free = sprintf "%9.2f",$free;
    $f_pct  = sprintf "%9.2f",$pct ;

    $total_size += $size;
    $total_free += $free;
    $total_used += $used;
    $total_df   += $numd;

    if ($g_history_to_file eq "Y")
    {
      if ($hist_flag)
      {
	system("echo '$filedate $filetime $title[$thishost] $ts . $size $used $dbms[$thishost]' >> $tmpflt");
      }
    }

    &histCreate("orantTSFull()",$thishost,"SPC",$ts,$size,$used);
    $gbtot_oraclent += ($size / 1000);

    ##print "titleraw[$thishost] ts=$ts size=$size used=$used gbtot_oraclent=$gbtot_oraclent\n";

    $color = "lime";
    $free = int($free);

    if ($stat eq "C")
    {
      &event("C",$thishost,"Oracle TS: $ts - ${pct}% Full - Critical ($free MB Free - Threshold: ${t_diskcrit[$thishost]}%)","TS","DBA621");
      $color = "red";
    }
    if ($stat eq "W")
    {
      &event("W",$thishost,"Oracle TS: $ts - ${pct}% Full - Warning ($free MB Free - Threshold: ${t_diskwarn[$thishost]}%)","TS","DBA622");
      $color = "yellow";
    }

    &logDetails($thishost,"
    <tr bgcolor=$color>
      <td>$f_s <b> $ts </b>
      <td>$f_s <b> $type </b>
      <td align=right>$f_s <b> $numd </b>
      <td align=right>$f_s <b> $f_size </b>
      <td align=right>$f_s <b> $f_used </b>
      <td align=right>$f_s <b> $f_free </b>
      <td align=right>$f_s <b> $f_pct </b>
      <td>$f_s <b> $stat </b>
    ");
  } 

  $system_size[$thishost] = $total_size / 1000;
  $system_used[$thishost] = $total_used / 1000;
  $grand_total_size += ($total_size / 1000);

  if ($total_size > 0)
  {
    $zpct = int(100 * ($total_used / $total_size));

    $total_size += $size;
    $total_free += $free;
    $total_used += $used;
    $total_df   += $numd;

    $f_total_size = sprintf "%9.2f",$total_size;
    $f_total_free = sprintf "%9.2f",$total_free;
    $f_total_used = sprintf "%9.2f",$total_used;
    $f_pct  = sprintf "%9.2f",$zpct ;

    &logDetails($thishost,"
    <tr bgcolor=$table_headbgcolor>
      <td>$f_s <b>Totals:</b>
      <td>$f_s 
      <td align=right>$f_s <b> $total_df  </b>
      <td align=right>$f_s <b> $f_total_size  </b>
      <td align=right>$f_s <b> $f_total_used  </b>
      <td align=right>$f_s <b> $f_total_free  </b>
      <td align=right>$f_s <b> $f_pct </b>
      <td align=right>$f_s &nbsp; 
    ");
  }

  if ($g_history_to_file eq "Y")
  {
    if ($hist_flag)
    {
      &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
      system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
    }
  }
  
  &logDetails($thishost,"</table><hr>");
}

# -----------------------------------------------------------------------------
1;
