# -----------------------------------------------------------------------------
sub sqlAlerts
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  my $events_18456_cnt = 0; 
  my @events_18456_details = (); 
  my $io_delay_cnt = 0; 

  %deadlocks = (); 
  my $this_line = ""; 

  ##print "up=$up[$thishost] title=$title[$thishost]\n";
  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  #if (&check_inhib($thishost) eq "Y")
  #{
  #  $up[$thishost] = "I";
  #  return;
  #}
  #if ($up[$thishost] eq "D")
  #{
  #  logit("(No software download)",$thishost);
  #  #
  #  # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
  #  #  D from a failed download, but the download_flag is set to 1. This is a
  #  #  place where the code is always executed for every instance, so I am
  #  #  adding a line to turn off the download_flag which will cause the
  #  #  download subroutine to retry the download next time. If that succeeds,
  #  #  the download subroutine will turn off the D value of "up".
  #  #
  #  return;
  #}

  #----  Old
  ## &remsh("$perlpath[$thishost] $probe[$thishost] checklog",$tmpfl3,$thishost);
  ## &remsh("$perlpath[$thishost] $probe[$thishost] checklog $mssql_log_min_sev[$thishost]",$tmpfl3,$thishost);
  #----  New
 
  #---- Process possible passed parms
  my $local_mssql_log_min_sev = $mssql_log_min_sev[$thishost]; 
  $local_mssql_log_min_sev = -99 if ! $local_mssql_log_min_sev;
  my $local_dbc_udm_stringcheck = $dbc_udm_stringcheck[$thishost]; 
  $local_dbc_udm_stringcheck = "?" if ! $local_dbc_udm_stringcheck;

  #---- OLD:
  # &remsh("$perlpath[$thishost] $probe[$thishost] checklog $local_mssql_log_min_sev $local_dbc_udm_stringcheck",$tmpfl3,$thishost);
  # &probeLog; 
  #---- NEW:
  #---- If the SQLUP PROBEOUT file exists and was updated within the last hour, then use it.
  #----   else, just do it the old (slow) way

  #---- 5.44.B - Just use the probeout_file, so skip all of this - remove this later
  ## if (-e "$probeout_sqlup_file[$thishost]")
  ## {
  ##   $z_mtime   = ( stat "$probeout_sqlup_file[$thishost]" ) [9];
  ##   $z_agesecs = time - $z_mtime;
  ## }
  ## else
  ## {
  ##   $z_agesecs = -1;
  ## }
  ## if ($z_agesecs != -1 && $zage_secs < 7200)
  ## {
  ##   &logit("Using PROBEOUT file ($probeout_sqlup_file[$thishost]) Instead of PROBING",$thishost);
  ##   use File::Copy;
  ##   copy("$probeout_sqlup_file[$thishost]", "$tmpfl3");
  ## }
  ## else
  ## {
  ##   &logit("PROBING for alert data",$thishost);
  ##   &remsh("$perlpath[$thishost] $probe[$thishost] checklog $local_mssql_log_min_sev $local_dbc_udm_stringcheck",$tmpfl3,$thishost);
  ## }
  ## &probeLog;

  #---- Read probeout
  open(PROBEOUT, "$probeout_file[$thishost]"  ) || &error_msg("Cannot open input $probeout_file[$thishost] - $!");
  
  my $sqlevent_flag = 0;
  my $sqlevent_text = "";
  my $sqleventagent_flag = 0;
  my $sqlcurrentlog_data = ""; 
  my $sqlcurrentlogagent_data = ""; 
  my $sql_db_log_event_cnt = 0;
  my $sql_db_log_event_data = "";
  my $sql_ag_log_event_cnt = 0;
  my $sql_ag_log_event_data = "";

  while(<PROBEOUT>)
  {
    &parse;

    #----  dbamon_mssql.pl 18456_Events: 1
    if ($F2 eq "18456_Events:")    
    {   
      $events_18456_cnt = $F3; 
      next;
    }

    #---- dbamon_mssql.pl 18456_Event_Details: 2013-04-14 08:32:22.480 Error: 18456, Severity: 14, State: 5.
    if ($F2 eq "18456_Event_Details:")    
    {   
      push (@events_18456_details, substr($F0,37)); 
      next;
    }

    #---- print "$P IODelayEvents: $io_delay_events\n";
    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "IODelayEvents:")  
    {
      if ($F3 > 0)
      {
        $ev_cat = "Perf";
        &event("P",$thishost,"Found $F3 I/O_Delay Message(s) in SQL Log - $io_delay_cnt Total Occurrences","SQL_IO_Delay","DBA664");
      }
      next;
    }
    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "IODelayCount:")  
    {
      #---- Save this stuff as a METRIC
      my $zkey = "SQL_IODelay_Count";
      $perf_readings[$thishost]{$zkey} = $F3;
      $io_delay_cnt = $F3;
      next;
    }

    #---- print "$P StackDumpEvents: $stackdump_events\n";
    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "StackDumpEvents:")  
    {
      if ($F3 > 0)
      {
	open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
	print TMPFL2 "Number of STACK DUMPs Found During This DBAmon Iteration: $F3

MSSQL Stack Dumps are potentially REALLY BAD. Look in your MSSQL Log for additional
details. There is some good information Google (the internet), so you can search for: 
MSSQL STACK DUMP + (some details from your STACK DUMP in the MSSQL log).
	";
	close(TMPFL2); 
        $ev_cat = "Avail";
	&event("C",$thishost,"STACK DUMP(s) Found in SQL Log","SQL_StackDump","DBA948", $tmpfl2);
      }
      next;
    }

    #---- print "$P MemPagedOutEvents: n\n";
    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "MemPagedOutEvents:")  
    {
      if ($F3 > 0)
      {
        $ev_cat = "Perf";
        &event("P",$thishost,"Found $F3 Memory_Paged_Out Message(s) in SQL Log","SQL_Mem_Paged_Out","DBA670");
      }
      next;
    }

    #---- dbamon_mssql.pl UDMStringCheckMsgCnt: 13 String_BACKED
    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "UDMStringCheckMsgCnt:")  
    {
      #---- Save this stuff as a METRIC
      my $zkey = "SQL_UDM_" . $F4;
      $perf_readings[$thishost]{$zkey} = $F3;
      next;
    }

    #---- DDP:<|>dbamon_mssql.pl<|>Deadlock_DDP_Packet:<|>2013-05-09 17:08:51.110<|>deadlock-list
    if ($F0 =~ /^DDP:/ && $F0 =~ /Deadlock_DDP_Packet:/)
    {
      &packetParse($F0);

      #print "F0=$F0\n"; 
      #foreach (@pa_words)
      #{
      #  print "pa_words[$_]=$pa_words[$_]\n"; 
      #}

      $dl_key  = $pa_words[2]; 
      $dl_line = $pa_words[3]; 

      ##print "dl_key=$dl_key dl_line=$dl_line\n"; 

      $deadlocks{$dl_key} .= $dl_line . "\n"; 
      next;
    }

    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "DeadlockEvents:")  
    {
      #---- Save this stuff as a METRIC
      my $zkey = "SQL_Deadlock_Count";
      $perf_readings[$thishost]{$zkey} = $F3;
      next;
    }

    #---- dbamon_mssql.pl SQL_Log_Rows: 1018
    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "SQL_Log_Rows:")  
    {
      #---- Save this stuff as a METRIC
      my $zkey = "SQL_ErrorLog_Rows";
      $perf_readings[$thishost]{$zkey} = $F3;
      next;
    }

    if ($F1 eq "Event:")  
    {
      $sqlevent_flag = 1;
      $sql_db_log_event_cnt++;
      $sql_db_log_event_data .= "$sql_db_log_event_cnt. $F0"; 
      next;
    }

    if ($F1 eq "EventAgent:")  
    {
      $sqleventagent_flag = 1;
      $sql_ag_log_event_cnt++;
      $sql_ag_log_event_data .= "$sql_ag_log_event_cnt. $F0"; 
      next;
    }

    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "CurrentLog:") 
    { 
      if    ($F0 =~ /backup/i) { $acolor = "lightgreen"; }
      elsif ($F0 =~ /error/i)  { $acolor = "pink"; } 
      else                     { $acolor = "lightgrey"; } 
  
      $sqlcurrentlog_data .= "<tr bgcolor=$acolor>" . substr($F0,28) . "\n" ; 
      next;
    }

    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "CurrentLogAgent:") 
    { 
      if   ($F0 =~ /error/i)  { $acolor = "pink"; } 
      else                    { $acolor = "lightgrey"; } 
  
      $sqlcurrentlogagent_data .= "<tr bgcolor=$acolor>" . substr($F0,33) . "\n" ; 
      next;
    }
  }
  close(PROBEOUT);

  my $zevent_flag = 0; 
  
  if ($sqlevent_flag == 1)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "-- Report of SQL DB Log Error(s) Found ($sql_db_log_event_cnt Errors):\n";
    print TMPFL2 "$sql_db_log_event_data";
    close(TMPFL2); 
    #---- Old
    ## &event("C",$thishost,"Found $sql_db_log_event_cnt SQL DB Log Alert(s)","MSSQL_SQL_Log","DBA651C",$tmpfl2);
    #---- New
    $ev_cat = "Avail";
    &event("C",$thishost,"Found New SQL DB Log Alert(s)","MSSQL_SQL_Log","DBA651C",$tmpfl2);
    $zevent_flag = 1; 
  }

  if ($sqleventagent_flag == 1)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "-- Report of SQL Agent Log Error(s) Found ($sql_ag_log_event_cnt Errors):\n";
    print TMPFL2 "$sql_ag_log_event_data";
    close(TMPFL2); 
    #---- Old
    ## &event("C",$thishost,"Found $sql_ag_log_event_cnt SQL Agent Log Alert(s)","MSSQL_SQL_Log","DBA658C",$tmpfl2);
    #---- New
    $ev_cat = "Avail";
    &event("C",$thishost,"Found New SQL Agent Log Alert(s)","MSSQL_Agent_Log","DBA658C",$tmpfl2);
    $zevent_flag = 1; 
  }

  #----  dbamon_mssql.pl 18456_Events: 1
  if ($events_18456_cnt > 0) 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "Number of 18456 Errors (invalid logins) found in SQL Error Log: $events_18456_cnt\n\n"; 
    print TMPFL2 "Details (first 100 entries):\n\n"; 
    foreach (@events_18456_details)
    {
      $_ =~ s/\</\{/g;
      $_ =~ s/\>/\}/g;
      print TMPFL2 $_; 
    }

    print TMPFL2 "\nCheck SQL Error Log for additional details."; 
    close(TMPFL2);

    $ev_cat = "Security";
    &event("S",$thishost,"MSSQL Error=18456 - $events_18456_cnt Invalid Login(s) Found in MSSQL DB Error Log","FailedSQLLogins=$events_18456_cnt","DBA942", $tmpfl2);
    $perf_readings[$thishost]{"SQL_Failed_Logins"} = $events_18456_cnt;
  }

  if ($zevent_flag == 0)
  {
    &logit("OK",$thishost); 
  }

  #---- Write last N lines of the CURRENT LOG

  &logDetails($thishost,"<br><a name='sqlAlerts'> <h3>MSSQL Current SQL Log - The Most Recent 50 Lines (Descending Timestamp)</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor style='font-family:$www_font;font-size:10pt;'>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Timestamp
    <th>$f_s Source
    <th>$f_s Text
  ");
  &logDetails($thishost,$sqlcurrentlog_data) ; 
  &logDetails($thishost,"</table>") ; 

  &logDetails($thishost,"<br><h3>MSSQL Current AGENT Log - The Most Recent 50 Lines (Descending Timestamp)</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor style='font-family:$www_font;font-size:10pt;'>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Timestamp
    <th>$f_s ErrorLevel
    <th>$f_s Text
  ");
  &logDetails($thishost,$sqlcurrentlogagent_data) ; 
  &logDetails($thishost,"</table><hr>") ; 

  #---- Process any deadlocks 
  &sqlAlertsDeadlocks;
}
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
sub sqlAlertsDeadlocks
# -----------------------------------------------------------------------------
{
  #---- Vars
  my $dl_this_priobject = ""; 
  my %dl_this_desc = (); 

  #---- See HOW MANY deadlocks we found
  $deadlocks_num = scalar keys %deadlocks;
  $t_deadlocks = 10; 
  if ($deadlock_num >= $t_deadlocks)
  {
    &phoneHome($thishost, "Found $deadlocks_num deadlocks (GE t_deadlocks=$t_deadlocks)", $probeout_file[$thishost]); 
  }

  #---- Process any deadlocks
  foreach $this_dl_ts (sort keys %deadlocks) 
  {
    my $debug_dl  = 0; 
    my $table_row = ""; 
    my $nbsp = "\&nbsp\;\&nbsp\;"; 

    print "this_dl_ts=$this_dl_ts\n" if $debug_dl; 

    #---- It would be very nice to see the first objectname= value in the title of the deadlock
    #----   So, we will read once through the rows for this $this_dl_ts to see if we find that
    #----   value. If we do, it will become part of the title that appears on the WWW list of
    #----   reports.
    %dl_this_desc = ();  #---- Clear this hash 
    foreach $this_line (split('\n',$deadlocks{$this_dl_ts} ))
    {
      #---- Extract some good data from the deadlock info
      if ($this_line =~ /objectname=/ && ! $dl_this_desc{'obj'}) 
      {
        $dl_this_desc{'obj'} = &nounFromString("objectname=", $this_line);
      }
      elsif ($this_line =~ /procname=/ && ! $dl_this_desc{'proc'}) 
      {
        $dl_this_desc{'proc'} = &nounFromString("procname=", $this_line);
      }
    }

    #---- Decide which DESC we want to use
    if    ($dl_this_desc{'obj'}  ne "") { $dl_this_priobject =  "Obj:$dl_this_desc{'obj'}";  }
    elsif ($dl_this_desc{'proc'} ne "") { $dl_this_priobject = "Proc:$dl_this_desc{'proc'}"; }
    else                                { $dl_this_priobject = "";  }
    #---- Just in case it's corn-fused
    if (length($dl_this_prioject) > 60) { $dl_this_project = substr($dl_this_project,0,60); } 

    my $sn_key = &snapshotsKeyGen("MSSQL_Deadlock_${this_dl_ts} ${dl_this_priobject}");
    &snapshotsInsert($thishost, $sn_key, 0, "MSSQL Deadlock \@ $this_dl_ts");

    my $table_heading = "<tr bgcolor=$table_headbgcolor>
      <th>$f_s Details of this Deadlock
    </tr>";
    &snapshotsInsert($thishost, $sn_key, 1, $table_heading);

    my $sn_seq      = 1;
    my $dl_alllines = ""; 
    my $dl_spid     = -999999; 
    my $dl_pid      = -999999; 
    my %dl_processes = (); 
    
    #---- This packet of data contains all of the lines of the report, concatenated.  
    #----   Now we will split the data into individual lines
    foreach $this_line (split('\n',$deadlocks{$this_dl_ts} ))
    {
      #print "  this_line=$this_line\n" if $debug_dl; 
      $dl_alllines .= "$this_line\n"; 
  
      #---- Convert leading blanks to &nbsp;
      $this_line =~ s/^\s/$nbsp/g;
 
      my $tr_color        = "white"; 
      my $tr_color_header = "tan"; 

      if ($this_line =~ /deadlock-list/i || $this_line =~ /process-list/i || $this_line =~ /resource-list/) 
      {
        $table_row = "<tr bgcolor=$tr_color_header > <td>$f_s <br> <b>$this_line (Section Heading) </b> <p>";
      }
      elsif ($this_line =~ /-list/i) 
      {
        $table_row = "<tr bgcolor=$tr_color_header > <td>$f_s <b>$this_line</b>";
      }
      elsif ($this_line =~ /executionstack/i) 
      {
        $table_row = "<tr bgcolor=$tr_color> <td>$f_s <b>$this_line (SQL for this SPID=$dl_spid):</b>";
      }
      elsif ($this_line =~ /inputbuf/i) 
      {
        $table_row = "<tr bgcolor=$tr_color> <td>$f_s <b>$this_line (Input Buffer for this SPID=$dl_spid):</b>";
      }
      elsif ($this_line =~ /process id=/i) 
      {
        $dl_spid = &nounFromString("spid=", $this_line);
        $dl_pid  = &nounFromString("process id=", $this_line);

        $dl_processes{$dl_pid} = $dl_spid;

        $table_row = "<tr bgcolor=$tr_color_header> <td>$f_s <b>SPID=$dl_spid PID=$dl_pid Process Information:<br><br>$this_line<br><br>Details for SPID=$dl_spid:<br></b>";
      }
      else
      {
        if ($this_line =~ /id=process/) 
        {
          #---- Figure out the SPID (and other info) for this processXXXXX values
          print "IDPROC this_line=$this_line\n" if $debug_dl;

          $dl_thispid  = &nounFromString("id=", $this_line);
          $dl_thisspid = $dl_processes{$dl_thispid}; 

          print "IDPROC dl_thispid=$dl_thispid dl_thisspid=$dl_thisspid\n" if $debug_dl;
           
          if ($dl_thisspid > 0) { $table_row = "<tr bgcolor=$tr_color> <td>$f_s $this_line <b>(SPID=$dl_thisspid)</b> "; }
          else                  { $table_row = "<tr bgcolor=$tr_color> <td>$f_s $this_line "; }
        }
        else
        {
          $table_row = "<tr bgcolor=$tr_color> <td>$f_s $this_line ";
        }
      }

      &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row);
    }
  }
}

# -----------------------------------------------------------------------------
1;
